<h1> ThreeFold Grid V4 Docs </h1>

<h2>Table of Contents</h2>

- [Introduction](#introduction)
- [Prerequisites](#prerequisites)
  - [Install the prerequisites on Ubuntu](#install-the-prerequisites-on-ubuntu)
  - [Install the prerequisites on MAC or Linux with Brew](#install-the-prerequisites-on-mac-or-linux-with-brew)
  - [Check if the Prerequisites Are Installed](#check-if-the-prerequisites-are-installed)
- [Clone the Repository](#clone-the-repository)
- [Preview the Website](#preview-the-website)
- [License](#license)
- [References](#references)
- [Contribute](#contribute)

---

## Introduction

This repository contains the code to deploy the ThreeFold Grid V4 documentation website, a project by [ThreeFold](https://threefold.io).

## Prerequisites

You need [npm](https://www.npmjs.com/) to run this website. 

To clone the repository, you need `git`.

To use the Makefile for quick deployment, you need `make`

### Install the prerequisites on Ubuntu
```
sudo apt update
sudo apt install nodejs
sudo apt install git
sudo apt install make
```

### Install the prerequisites on MAC or Linux with Brew

- [Install Brew](https://brew.sh/)
    ``` 
    /bin/bash -c "$(curl -fsSL https://raw.githubusercontent.com/Homebrew/install/HEAD/install.sh)"
    ```
- Install the prerequisites
    ```
    brew install node
    brew install git
    brew install make
    ```

### Check if the Prerequisites Are Installed

```
npm --version
git version
make --version
```

## Clone the Repository


```
git clone https://git.ourworld.tf/tfgrid/docs_tfgrid4
cd docs_tfgrid4
```

For more information, read the original [AstroWind docs](./docs_starlight/starlight_README.md).

## Preview the Website

You can preview the website with those two lines.

```
npm install
npm run dev
```

The equivalent can be achieved using the Makefile:

```
make run
```

## License

**INCA Docs** is licensed under the Apache 2.0 license — see the [LICENSE](../LICENSE) file for details.

## References

This website is based on the [AstroWind Starlight repo](https://github.com/withastro/starlight).

We changed the license from MIT to Apache 2.0 to suit this specific project.

## Contribute

To contribute to this repository:

- Make a new branch with `development_` as a prefix (e.g. `development_update`)
- Make changes locally on your code editor
- Push changes to the new branch
- Make a pull request to `development` branch

The code owners will merge `development` branch to `main` branch.