import { defineConfig } from 'astro/config';
import starlight from '@astrojs/starlight';

// https://astro.build/config
export default defineConfig({
	integrations: [
		starlight({
			title: 'ThreeFold Docs',
			social: {
				github: 'https://github.com/threefoldtech',
				telegram: 'https://t.me/threefold',
				'x.com': 'https://x.com/threefold_io',
			},
			sidebar: [
				{
					label: 'Start Here',
					items: [

						{ label: 'Getting Started', link: '/start_here/getting_started/' },
					],
				},
				{
					label: 'Steps',
					items: [

						{ label: 'Install ThreeFold Connect', link: '/guides/threefold_connect/' },
						{ label: 'Create an INCA Farm', link: '/guides/create_farm/' },
						{ label: 'Get INCA Nodes', link: '/guides/get_inca_nodes/' },
						{ label: 'Connect Your Nodes', link: '/guides/connect_the_nodes/' },
						{ label: 'Manage Your Rewards', link: '/guides/manage_rewards/' },
					],
				},
				{
					label: 'Resources',
					items: [

						{ label: 'How to Use the Bots', link: '/resources/resources_introduction/' },
						{ label: 'Node Status Bot', link: '/resources/node_status_bot/' },
						{ label: 'Farmerbot', link: '/resources/farmerbot/' },
					],
				},
				{
					label: 'References',
					items: [

						{ label: 'Glossary', link: '/references/glossary/' },
						{ label: 'Whitepaper', link: '/references/inca_whitepaper/' },
						{ label: 'Litepaper', link: '/references/tfgrid4_litepaper/' },
						{ label: 'Disclaimer', link: '/references/disclaimer/' },
					],
				},
				{
					label: 'Legal',
					items: [

						{ label: 'Terms and Conditions', link: '/legal/terms_and_conditions/' },
						{ label: 'Privacy Policy', link: '/legal/privacy_policy/' },
					],
				},
			],
			head: [
				{
				tag: 'script',
				attrs: {
					src: '/crisp.js',
				},
				},
			],
		}),
	],
});
